-- Set RaidGuy Window Positions
local Settings = Turbine.PluginData.Load(Turbine.DataScope.Character, "RaidGuySettings");
local WindX,WindY=Turbine.UI.Display:GetWidth()/2-100,Turbine.UI.Display:GetHeight()/2-100;
if Settings~=nil then
	if Settings["WindPosX"]~=nil then WindX=Settings["WindPosX"] end
	if Settings["WindPosY"]~=nil then WindY=Settings["WindPosY"] end
end


-- Create Window
wRaidGuy = Turbine.UI.Lotro.Window();
wRaidGuy:SetSize(215,400);
wRaidGuy:SetPosition(WindX,WindY);
wRaidGuy:SetText("RaidGuy");
if Settings~=nil then wRaidGuy:SetVisible(Settings["WindState"]) end

-- Counters
ResetCount = 6;
Count = ResetCount;
ypos = 10; -- starting line

-- Channels
RaidChannel = "/ra ";
FellowChannel = "/f ";
LocalChannel = "/say ";
Channel = RaidChannel;

-- Commands & Shouts
Ready = "/readycheck";
Engage = "Engage!";
Target = "Attack ;target" .. "!";

-- Create Fellowship Raid & Local Buttons
ChannelsLabel = Turbine.UI.Label();
ChannelsLabel:SetParent(wRaidGuy);
ChannelsLabel:SetText("Channels");	
ChannelsLabel:SetFont(Turbine.UI.Lotro.Font.Verdana12);
ChannelsLabel:SetForeColor(Turbine.UI.Color(1,1,0));
ChannelsLabel:SetSize(150,15);
ChannelsLabel:SetTextAlignment(Turbine.UI.ContentAlignment.Middle);
ChannelsLabel:SetPosition(90,wRaidGuy:GetHeight()-130)

RaidButton = Turbine.UI.Lotro.Button();
RaidButton:SetParent(wRaidGuy);
RaidButton:SetSize(185,25);
RaidButton:SetPosition(15,wRaidGuy:GetHeight()-110);
RaidButton:SetText("Set Channel To Raid");

RaidButton.MouseClick = function()
	Channel = RaidChannel;
	UpdateAliases(Channel);
	Turbine.Shell.WriteLine("Raid Channel Selected");
end

FellowshipButton = Turbine.UI.Lotro.Button();
FellowshipButton:SetParent(wRaidGuy);
FellowshipButton:SetSize(185,25);
FellowshipButton:SetPosition(15,wRaidGuy:GetHeight()-80);
FellowshipButton:SetText("Set Channel To Fellowship");

FellowshipButton.MouseClick = function()
	Channel = FellowChannel;
	UpdateAliases(Channel);
	Turbine.Shell.WriteLine("Fellowship Channel Selected");
end

LocalButton = Turbine.UI.Lotro.Button();
LocalButton:SetParent(wRaidGuy);
LocalButton:SetSize(185,25);
LocalButton:SetPosition(15,wRaidGuy:GetHeight()-50);
LocalButton:SetText("Set Channel To Local");

LocalButton.MouseClick = function()
	Channel = LocalChannel;
	UpdateAliases(Channel);
	Turbine.Shell.WriteLine("Local Channel Selected");
end

-- Actions
ypos = ypos + 20;
ActionsLabel = Turbine.UI.Label();
ActionsLabel:SetParent(wRaidGuy);
ActionsLabel:SetText("Actions");	
ActionsLabel:SetFont(Turbine.UI.Lotro.Font.Verdana12);
ActionsLabel:SetForeColor(Turbine.UI.Color(1,1,0));
ActionsLabel:SetSize(150,15);
ActionsLabel:SetTextAlignment(Turbine.UI.ContentAlignment.Middle);
ActionsLabel:SetPosition(90,35)

-- ReadyCheck Button & Quickslot
ypos = ypos + 20;
ReadyCheckButton = Turbine.UI.Button();
ReadyCheckButton:SetParent(wRaidGuy);
ReadyCheckButton:SetSize(32,32);
ReadyCheckButton:SetBackground("RadicusPlugins/RaidGuy/Resources/ReadyCheck.tga");
ReadyCheckButton:SetPosition(20,ypos);
ReadyCheckButton:SetVisible(true);

ReadyCheckqs=Turbine.UI.Lotro.Quickslot();
ReadyCheckqs:SetParent(ReadyCheckButton);
ReadyCheckqs:SetSize(ReadyCheckButton:GetWidth()+34,ReadyCheckButton:GetHeight()+34);
ReadyCheckqs:SetPosition(-34,-34);
ReadyCheckqs:SetAllowDrop(false);
ReadyCheckqs.DragDrop=function(sender)
	local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"");
	sc:SetData(Ready);
	sender:SetShortcut(sc);
	Turbine.Shell.WriteLine(sc);
end
ReadyCheckqs:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, Ready));
ReadyCheckqs.AliasText=Ready;

ReadyCheckLabel = Turbine.UI.Label();
ReadyCheckLabel:SetParent(wRaidGuy);
ReadyCheckLabel:SetText("Perform Ready Check");	
ReadyCheckLabel:SetPosition(60,ypos+10)
ReadyCheckLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
ReadyCheckLabel:SetForeColor(Turbine.UI.Color(1,1,0));
ReadyCheckLabel:SetSize(150,15);
ReadyCheckLabel:SetTextAlignment(Turbine.UI.ContentAlignment.Left);

-- Countdown Button & Quickslot
ypos=ypos+40;
CountButton = Turbine.UI.Button();
CountButton:SetParent(wRaidGuy);
CountButton:SetSize(32,32);
CountButton:SetBackground("RadicusPlugins/RaidGuy/Resources/Count.tga");
CountButton:SetPosition(20,ypos);
CountButton:SetVisible(true);

Countqs = Turbine.UI.Lotro.Quickslot();
Countqs:SetParent(CountButton);
Countqs:SetSize(CountButton:GetWidth()+34,CountButton:GetHeight()+34);
Countqs:SetPosition(-34,-34);
Countqs:SetAllowDrop(false);
Countqs.DragDrop=function(sender)
	local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"");
	sc:SetData(Channel .. Count);
	sender:SetShortcut(sc);
	Turbine.Shell.WriteLine(sc);
end

CountLabel = Turbine.UI.Label();
CountLabel:SetParent(wRaidGuy);
CountLabel:SetText("Countdown");	
CountLabel:SetPosition(60,ypos+10)
CountLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
CountLabel:SetForeColor(Turbine.UI.Color(1,1,0));
CountLabel:SetSize(150,15);
CountLabel:SetTextAlignment(Turbine.UI.ContentAlignment.Left);

-- Reset Timer Button
ResetButton = Turbine.UI.Lotro.Button();
ResetButton:SetParent(wRaidGuy);
ResetButton:SetSize(40,25);
ResetButton:SetPosition(160,ypos+7);
ResetButton:SetText("Reset");

ResetButton.MouseClick = function()
	Count = ResetCount;
	UpdateAliases(Channel);
	Turbine.Shell.WriteLine("Counter Reset");
end

-- Shouts
ypos = ypos + 40;
ShoutsLabel = Turbine.UI.Label();
ShoutsLabel:SetParent(wRaidGuy);
ShoutsLabel:SetText("Shouts");	
ShoutsLabel:SetFont(Turbine.UI.Lotro.Font.Verdana12);
ShoutsLabel:SetForeColor(Turbine.UI.Color(1,1,0));
ShoutsLabel:SetSize(150,15);
ShoutsLabel:SetTextAlignment(Turbine.UI.ContentAlignment.Middle);
ShoutsLabel:SetPosition(90,ypos)

-- Engage Button & Quickslot
ypos = ypos + 20;
EngageButton = Turbine.UI.Button();
EngageButton:SetParent(wRaidGuy);
EngageButton:SetSize(32,32);
EngageButton:SetBackground("RadicusPlugins/RaidGuy/Resources/Engage.tga");
EngageButton:SetPosition(20,ypos);
EngageButton:SetVisible(true);

Engageqs = Turbine.UI.Lotro.Quickslot();
Engageqs:SetParent(EngageButton);
Engageqs:SetSize(EngageButton:GetWidth()+34,EngageButton:GetHeight()+34);
Engageqs:SetPosition(-34,-34);
Engageqs:SetAllowDrop(false);
Engageqs.DragDrop=function(sender)
	local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, "");
	sc:SetData(Channel .. Engage);
	sender:SetShortcut(sc);
	Turbine.Shell.WriteLine(sc);
end

EngageLabel = Turbine.UI.Label();
EngageLabel:SetParent(wRaidGuy);
EngageLabel:SetText(Engage);	
EngageLabel:SetPosition(60,ypos+10)
EngageLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
EngageLabel:SetForeColor(Turbine.UI.Color(1,1,0));
EngageLabel:SetSize(100,15);
EngageLabel:SetTextAlignment(Turbine.UI.ContentAlignment.Left);

-- Target Button & Quickslot
ypos = ypos + 40;
TargetButton = Turbine.UI.Button();
TargetButton:SetParent(wRaidGuy);
TargetButton:SetSize(32,32);
TargetButton:SetBackground("RadicusPlugins/RaidGuy/Resources/Target.tga");
TargetButton:SetPosition(20,ypos);
TargetButton:SetVisible(true);

Targetqs = Turbine.UI.Lotro.Quickslot();
Targetqs:SetParent(TargetButton);
Targetqs:SetSize(TargetButton:GetWidth()+34,TargetButton:GetHeight()+34);
Targetqs:SetPosition(-34,-34);
Targetqs:SetAllowDrop(false);
Targetqs.DragDrop=function(sender)
	local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"");
	sc:SetData(Channel .. Target);
	sender:SetShortcut(sc);
	Turbine.Shell.WriteLine(sc);
end

TargetLabel = Turbine.UI.Label();
TargetLabel:SetParent(wRaidGuy);
TargetLabel:SetText(Target);	
TargetLabel:SetPosition(60,ypos+10)
TargetLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
TargetLabel:SetForeColor(Turbine.UI.Color(1,1,0));
TargetLabel:SetSize(150,15);
TargetLabel:SetTextAlignment(Turbine.UI.ContentAlignment.Left);

-----------------------------------------------------------------------------------------------------------------------------
-- Update Counter Stuff
Countqs.MouseClick = function(sender,args)
	Count = Count - 1;
	UpdateAliases(Channel);
end

-- Update Aliases
function UpdateAliases(Channel)
	if Count <= 0 then
		CountText = Engage;
		Count = 0;
	else
		CountText = "on " .. tostring(Count);
	end
	Countqs:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, Channel .. CountText));
	Countqs.AliasText=Channel .. CountText;

	Engageqs:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, Channel .. Engage));
	Engageqs.AliasText=Channel .. Engage;

	Targetqs:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, Channel .. Target));
	Targetqs.AliasText=Channel .. Target;
end

-- Initial Update Aliases for all buttons
UpdateAliases(Channel);